#include <Rcpp.h>

using namespace Rcpp;

// [[Rcpp::export]]
Rcpp::NumericVector backmle(Rcpp::NumericVector x, Rcpp::NumericVector par) {
           
    double A = par[0];
    double B = par[1];
    
   
    if(par[2]==1.0) {
        double old,p,num,denom,ym;
        double a[2];
    
        a[0] = 1.0;
        ym = mean(x);
        p = par[3];
        for(int j=0;j<100;++j) {
            old = p;
            if(A!=0) a[0] = exp(-old*A);
            a[1] = exp(-old*B);
            num = 1.0/old - ym - (B*a[1]-A*a[0])/(a[0]-a[1]);
            denom = (-1.0/old/old) + (B-A)*(B-A)*a[0]*a[1]/(a[0]-a[1])/(a[0]-a[1]);
            p = old- num/denom;
            if(std::abs(old-p)<1/1e7) break;    
        }
        par[0]=p;
    }
    if(par[2]==2.0) {
        double old[2],p[2],ym[2];
        
        double tmp,a1,a2,b11,b12,b22;
        
        ym[0] = mean(log(x));
        ym[1] = mean(log(1.0-x));

        p[0] = par[3];
        p[1] = par[4];
        for(int j=0;j<100;++j) {
            old[0] = p[0];
            old[1] = p[1];
            tmp = R::digamma(p[0]+p[1]);
            a1 = tmp-R::digamma(p[0])+ym[0];
            a2 = tmp-R::digamma(p[1])+ym[1];
            b12 = R::trigamma(p[0]+p[1]);
            b11 = b12-R::trigamma(p[0]);
            b22 = b12-R::trigamma(p[1]);
            
            p[0] = old[0] - (b22*a1-b12*a2)/(b11*b22-b12*b12);
            p[1] = old[1] - (b11*a2-b12*a1)/(b11*b22-b12*b12);
            if(std::abs(old[0]-p[0])+std::abs(old[1]-p[1])<0.00001) break;    
        }
        par[0]=p[0];
        par[1]=p[1];
    } 
    return par;
}